/**
 * -------------------------------------------------------- *
 * ------------------- ПРИМЕРЫ МАССИВЫ -------------------- *
 * -------------------------------------------------------- *
 */

/**
 * -------------------------------------------------------- *
 * ------------------ ОБЪЯВЛЕНИЕ МАССИВА ------------------ *
 *                      new Array и []                      *
 */
//Объявить массив можно следующим образом:
let mass1 = new Array();
// либо объявить короткой записью
let mass2 = [];
// такие массивы будут пустыми
console.log(mass1); // []
console.log(mass2); // []

/**
 * -------------------------------------------------------- *
 * ------------------ ОБЪЯВЛЕНИЕ МАССИВА ------------------ *
 *                     элементы массива                     *
 */
let mass_ = ['Jim', 'Jack', 'Bob'];
console.log(mass_[0]); // Jim
console.log(mass_[1]); // Jack
console.log(mass_[2]); // Bob
console.log(mass_[3]); // undefined
console.log(mass_); // [ 'Jim', 'Jack', 'Bob' ]

/**
 * -------------------------------------------------------- *
 * ------------------ ЭЛЕМЕНТЫ МАССИВА -------------------- *
 *                     пустые элементы                      *
 */
// массив mass размеров из 5ти элементов
let mass = new Array(5);
// присвоим последнему элементу значение 5
mass[4] = 5;
console.log(mass); // [ <4 empty items>, 5 ]
mass[0] = 1;
console.log(mass); // [ 1, <3 empty items>, 5 ]

/**
 * -------------------------------------------------------- *
 * ------------------ ЭЛЕМЕНТЫ МАССИВА -------------------- *
 *                  тип хранимых значений                   *
 */
// элементом массива может быть какой угодно тип, даже какой-нибудь объект
// разные типы значений
let arr = [
    'Джим',
    { name: 'Джон' },
    true,
    function () { console.log('Hello!'); }
];
console.log(arr[0]); // Джим
console.log(arr[1].name); // Джон
console.log(arr[2]); // true
// получить элемент с индексом 3 (функция) и выполнить её
arr[3](); // Hello!

/**
 * -------------------------------------------------------- *
 * -------------------- МЕТОДЫ МАССИВА -------------------- *
 *                           Pop                            *
 */
let students = ["Вася", "Аня", "Петя", "Катя"];
console.log(students) // [ 'Вася', 'Аня', 'Петя', 'Катя' ]
console.log(students.pop()); // удаляем "Катя" и выводим его
console.log(students) // [ 'Вася', 'Аня', 'Петя' ]

/**
 * -------------------------------------------------------- *
 * -------------------- МЕТОДЫ МАССИВА -------------------- *
 *                           Push                           *
 */
let students2 = ["Вася", "Аня", "Петя"];
console.log(students2) // [ 'Вася', 'Аня', 'Петя' ]
students2.push("Катя");
console.log(students2) // [ 'Вася', 'Аня', 'Петя', 'Катя' ]

/**
 * -------------------------------------------------------- *
 * -------------------- МЕТОДЫ МАССИВА -------------------- *
 *                           Shift                           *
 */
let students3 = ["Вася", "Аня", "Петя", "Катя"];
console.log(students3) // [ 'Вася', 'Аня', 'Петя', 'Катя' ]
console.log(students3.shift()); // удаляем "Вася" и выводим его
console.log(students3) // [ 'Аня', 'Петя', 'Катя' ]

/**
 * -------------------------------------------------------- *
 * -------------------- МЕТОДЫ МАССИВА -------------------- *
 *                        Unshift                           *
 */
let students4 = ["Аня", "Петя", "Катя"];
console.log(students4) // [ 'Аня', 'Петя', 'Катя' ]
students4.unshift("Вася"); // добавляем 'Вася'
console.log(students4) // [ 'Вася', 'Аня', 'Петя', 'Катя' ]

/**
 * -------------------------------------------------------- *
 * -------------------- МЕТОДЫ МАССИВА -------------------- *
 *        добавлять можно много, удалять по одному          *
 */
let students5 = ["Катя"];
console.log(students5) // [ 'Катя' ]
students5.unshift("Вася", "Коля"); // добавляем 'Вася','Коля'
console.log(students5); // [ 'Вася', 'Коля','Катя' ]
students5.push("Аня", "Петя"); // добавляем 'Аня','Петя'
console.log(students5) // [ 'Вася','Коля','Катя','Аня','Петя' ]

/**
 * -------------------------------------------------------- *
 * -------------------- ДЛИНА МАССИВА --------------------- *
 *                     свойство length                      *
 */
// как можно использовать length
// пусть есть обычный массив
let mass__ = [1, 2, 3]
// выведем его длину
console.log(mass__.length); // 3
console.log(mass__); // [ 1, 2, 3 ]
// а теперь просто сократим наш массив
mass__.length = 1;
console.log(mass__); // [ 1 ]
// как альтернатива методу push
mass__[mass__.length] = 3;
console.log(mass__); // [ 1, 3 ]

/**
 * -------------------------------------------------------- *
 * ----------------- МНОГОМЕРНЫЕ МАССИВЫ ------------------ *
 *                    элементы - массивы                    *
 */
let matrix = [
    [1, 3, 7],
    [6, 3, 5],
    [7, 3, 5],
]
console.log(matrix[1][0]);// 6
console.log(matrix[2][1]);// 3

/**
 * -------------------------------------------------------- *
 * --------------------- ОБХОД МАССИВА -------------------- *
 *                         цикл for                         *
 */
// классический пример обхода всего массива
let mass__2 = [1, 2, 4, 8, 4, 7, 3, 5, 7, 4];
for (let i = 0; i < mass__2.length; i++) {
    // обращаемся к элементам массива по индексу
    console.log(mass__2[i]);
}

/**
 * -------------------------------------------------------- *
 * --------------------- ОБХОД МАССИВА -------------------- *
 *                      fo...in for..of                     *
 */
// пройтись по значениям объекта
// переменной element будет
// присвоено значение элемента массива
// к которому мы обращаемся на данной итерации
for (let element of mass) {
    console.log(element);
}

for (let key in mass) { // Но на деле так делать не стоит!
    console.log(mass[key]);
}

/**
 * -------------------------------------------------------- *
 * ---------------------- ТИП МАССИВА --------------------- *
 *                    приведение к строке                   *
 */
let arr_ = [1, 2, 3];
console.log(arr_); // 1,2,3
console.log(String(arr_) === '1,2,3'); // true

/**
 * -------------------------------------------------------- *
 * --------------- ЕЩЕ МЕТОДЫ МАССИВА --------------------- *
 *                       "срезы"                            *
 */
let mass___ = [1, 2, 3, 4, 5, 6, 7, 8, 9, 0];
// метод splice вырезает элементы из массива
console.log(mass___);
// начиная с индекса 1 удалим 3 элемента
// при этом он возвращает удаленные элементы
// как это делает pop
let del_elem = mass___.splice(1, 3);
console.log(del_elem); // что удалили
// [ 2, 3, 4 ]
console.log(mass___); // что осталось
// [              
//   1, 5, 6, 7,  
//   8, 9, 0      
// ] 

// метод slice ожидает два индекса
// он копирует элементы между указанными индексами
// в новый массив
mass___ = [1, 2, 3, 4, 5, 6, 7, 8, 9, 0];
let new_arr = mass___.slice(2, 4);
console.log(new_arr); // [ 3, 4 ]
// а так можно скопировать весь массив
new_arr = mass___.slice();
console.log(new_arr);
// [1,2,3,4,5,6,7,8,9,0]